'School Year Calendar
'by Charles Dietz 08-15-2009
'email: chasdietz@verizon.net
'website: http://www.cgdsoftware.com
'-------------------------------------------------------------------------------------------------------------

#COMPILE EXE
#DIM ALL
#INCLUDE "WIN32API.INC"
'#INCLUDE "COMDLG32.INC"
'#INCLUDE "COMMCTRL.INC"
'#INCLUDE "debug.inc"
#INCLUDE "schoolCalendar.inc"
#RESOURCE "schoolCalendar.pbr"

$ver = "1.27"

FUNCTION PBMAIN
   LOCAL hSysMenu, nStyle, wi, ht, i, m, n AS LONG
   'initialize combobox of years
   DIM yr(3) AS STRING
   m = VAL(LEFT$(DATE$, 2))
   n = VAL(RIGHT$(DATE$, 4))
   IF m <= 6 THEN DECR n
   year = n 
   FOR i = 0 TO 3 
      yr(i) = STR$(n + i) + "-" + TRIM$(STR$(n + i + 1))
   NEXT i
   'initialize combobox of years
   DIM months(5) AS STRING
   months(0) = "Sep-Oct"
   months(1) = "Nov-Dec"
   months(2) = "Jan-Feb"
   months(3) = "Mar-Apr"
   months(4) = "May-Jun"
   months(5) = "Jul-Aug"

   wi = 240: ht = 150
   DIALOG NEW 0, "School Year Calendar", , , wi, ht, %WS_SYSMENU TO hDlg
   CONTROL ADD LABEL, hDlg, -1, "School year:", 20, 15, 70, 12
   CONTROL ADD COMBOBOX, hDlg, %IDC_Year, yr(), 20, 25, 70, 80
   nStyle = %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DROPDOWNLIST
   CONTROL ADD LABEL, hDlg, -1, "2-Month Period:", 120, 15, 80, 12
   CONTROL ADD COMBOBOX, hDlg, %IDC_Months, months(), 120, 25, 60, 100, nStyle
   
   CONTROL ADD BUTTON, hDlg, %IDC_Holidays, "&Holidays", wi - 180, ht - 50, 50, 25
   CONTROL ADD BUTTON, hDlg, %IDOK, "&Print", wi - 125, ht - 50, 50, 25
   CONTROL ADD BUTTON, hDlg, %IDCANCEL, "&Exit", wi - 70, ht - 50, 50, 25
   hSysMenu = GetSystemMenu(hDlg, 0)
   InsertMenu hSysMenu, 2, %MF_BYPOSITION OR %MF_STRING, %ID_SysMenu + 1, "About "
   RemoveMenu hSysMenu, 0, %MF_BYPOSITION
   DIALOG SHOW MODAL hDlg, CALL mainDlgProc
END FUNCTION

CALLBACK FUNCTION mainDlgProc()
   LOCAL i, n, fileNum AS LONG
   LOCAL s AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         DIM moName(12), dayName(7)
         moName(1) = "January": moName(2) = "February": moName(3) = "March"
         moName(4) = "April": moName(5) = "May": moName(6) = "June"
         moName(7) = "July": moName(8) = "August": moName(9) = "September"
         moName(10) = "October": moName(11) = "November": moName(12) = "December"
         dayName(1) = "Sun": dayName(2) = "Mon": dayName(3) = "Tue": dayName(4) = "Wed"
         dayName(5) = "Thu": dayName(6) = "Fri": dayName(7) = "Sat"
         COMBOBOX SELECT CB.HNDL, %IDC_Year, 1
         COMBOBOX SELECT CB.HNDL, %IDC_Months, 1
         CONTROL SET FOCUS CBHNDL, %IDC_Year
         
         'dataFolder = specialFolder(%CSIDL_COMMON_DOCUMENTS)
         dataFolder = specialFolder(%CSIDL_COMMON_APPDATA)
         IF LEN(dataFolder) = 0 THEN dataFolder = "C:\My Documents"
         dataFolder = dataFolder + "\cgdSoftware\School Calendar"
         IF ISFILE(dataFolder) = 0 THEN createFolder dataFolder
         dataFolder = dataFolder + "\" 
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDC_Holidays
               IF NOT alreadyLoaded THEN loadHolidays
               defineHolidays
            CASE %IDOK
               IF NOT alreadyLoaded THEN loadHolidays
               printSchoolCalendar
            CASE %IDCANCEL 'save and shut down 
               fileName = dataFolder + "Holidays" + RIGHT$(STR$(year), 2) + ".txt"
               IF savChanges OR ISFILE(fileName) = 0 THEN
                  n = %IDYES
                  IF savChanges THEN
                     CONTROL GET TEXT CB.HNDL, %IDC_Year TO s
                     s = "Save holiday file for " + TRIM$(s)
                     n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, "Save Holidays")
                  END IF   
                  IF n = %IDYES THEN
                     fileNum = FREEFILE
                     OPEN fileName FOR OUTPUT AS fileNum
                     WRITE #fileNum, year, shade: n = numHolidays - 1
                     FOR i = 1 TO numHolidays
                        WRITE #fileNum, holidayName(i), holidayDate1(i), holidayDate2(i)
                     NEXT i
                     WRITE #fileNum,
                     CLOSE #fileNum
                  END IF
               END IF
               DIALOG END CBHNDL
         END SELECT
         CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      CASE %WM_SYSCOMMAND
         IF CBWPARAM = %SC_CLOSE THEN
            DIALOG SEND CBHNDL, %WM_COMMAND, %IDCANCEL, 0
         ELSEIF CBWPARAM = %ID_SysMenu + 1 THEN
            s = "School Calendar" + $CRLF + "Version " + $ver + $CRLF + $CRLF _
              + "   by Charles Dietz" + $CRLF + "   Email: chasdietz@verizon.net   " + $CRLF _
              + "   Website: http://www.cgdsoftware.com"
            MSGBOX s, , "About"
         END IF
   END SELECT
END FUNCTION

SUB loadHolidays()
   LOCAL i, fileNum, yr AS LONG, s AS STRING
   DIM holidayName(1 TO 50), holidayDate1(1 TO 50), holidayDate2(1 TO 50), holidays(12, 31)
   fileName = "Holidays" + RIGHT$(STR$(year), 2) + ".txt" 
   IF LEN(DIR$(dataFolder + fileName, 6)) = 0 THEN fileName = "Holidays.txt"
   IF LEN(DIR$(dataFolder + fileName, 6)) THEN 'file exists
      fileNum = FREEFILE
      OPEN dataFolder + fileName FOR INPUT AS fileNum
      numHolidays = 0
      IF LEN(fileName) > 12 THEN
         LINE INPUT #fileNum, s:
         yr = VAL(PARSE$(s, "", 1))
         shade = VAL(PARSE$(s, "", 2))
      END IF
      WHILE NOT EOF(fileNum)
         LINE INPUT #fileNum, s 
         IF LEN(s) THEN
            INCR i
            holidayName(i) = PARSE$(s, "", 1)
            holidayDate1(i) = VAL(PARSE$(s, "", 2))
            holidayDate2(i) = VAL(PARSE$(s, "", 3))
         END IF
      WEND
      CLOSE #fileNum
      IF shade = 0 THEN shade = 40
      shade0 = shade: alreadyLoaded = -1
   END IF
   numHolidays = i
   getHolidayDates
   markHolidays
END SUB

SUB markHolidays()
   LOCAL i, k, m, n, mo, day, yr, test AS LONG
   REDIM holidays(12, 31)
   FOR i = 1 TO numHolidays
      n = holidayDate1(i)
      mo = n \ 100: day = n MOD 100
      yr = VAL(RIGHT$(DATE$, 4))
      IF mo <= 8 THEN INCR yr
      k = dayOfWeek(mo, day, yr)
      IF k = 0 THEN 'Sun, incr holiday to Mon
         INCR day: IF day > daysInMonth(mo, yr) THEN day = 1: INCR mo
         IF mo > 12 THEN mo = 1: INCR yr
      ELSEIF k = 6 THEN 'Sat, decr holiday to Fri
         DECR day: 
         IF day < 1 THEN 
            DECR mo: IF mo < 1 THEN mo = 12: DECR yr 
            day = daysInMonth(mo, yr)
         END IF   
      END IF 
      holidays(mo, day) = 1
      m = holidayDate2(i)
      test = 100 * mo + day 
      IF m THEN
         DO WHILE test <> m 
            INCR day
            IF day > daysInMonth(mo, yr) THEN
               day = 1: INCR mo: IF mo > 12 THEN mo = 1: INCR yr 
            END IF
            k = dayOfWeek(mo, day, yr)
            test = 100 * mo + day 
            IF k >=1 AND k <= 5 THEN holidays(mo, day) = 1
         LOOP 
      END IF
   NEXT i
END SUB

SUB PrintSchoolCalendar()
   LOCAL nStyle AS LONG
   DIALOG NEW hDlg, "Print Attendance Record", , , 150, 160, %WS_SYSMENU TO hPrn
   CONTROL ADD OPTION, hPrn, %IDC_2Mo,"Print 2-mo period", 10, 15, 100, 12
   CONTROL ADD OPTION, hPrn, %IDC_All,"Print all months", 10, 30, 100, 12
   
   CONTROL ADD LABEL, hPrn, -1, "Holiday Shade:", 10, 55, 60, 12
   CONTROL ADD LABEL, hPrn, %IDC_ShadeVal, "", 60, 55, 30, 12
   nStyle = %WS_CHILD OR %WS_VISIBLE OR %TBS_HORZ OR %TBS_TOP OR %WS_TABSTOP
   CONTROL ADD "msctls_trackbar32", hPrn, %IDC_Shade, "", 10, 70, 120, 15, nStyle, 0
   CONTROL SEND hDlg, %IDC_Shade, %TBM_SETTICFREQ, 20, 20
   CONTROL SEND hDlg, %IDC_Shade, %TBM_SETRANGE, 1, MAKLNG(0, 100)

   CONTROL ADD LABEL, hPrn, -1, "Darker", 110, 90, 25, 10
   CONTROL ADD LABEL, hPrn, -1, "Lighter", 10, 90, 25, 10
   CONTROL ADD BUTTON, hPrn, %IDOK, "&Ok", 40, 115, 40, 20, %WS_TABSTOP OR %BS_DEFAULT
   CONTROL ADD BUTTON, hPrn, %IDCANCEL, "&Cancel", 85, 115, 40, 20
   DIALOG SHOW MODAL hPrn, CALL PrintSchoolCalendarProc
END SUB

CALLBACK FUNCTION PrintSchoolCalendarProc()
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL SET OPTION CB.HNDL, %IDC_2Mo, %IDC_2Mo, %IDC_All 
         'set trackbar shade control
         CONTROL SET TEXT CB.HNDL, %IDC_ShadeVal, STR$(shade)
         CONTROL SEND CB.HNDL, %IDC_Shade, %TBM_SETPOS, 1, shade
         CONTROL SEND CB.HNDL, %IDC_Shade, %TBM_SETTIC, 1, 50
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN
            CONTROL SEND CB.HNDL, %IDC_Shade, %TBM_GETPOS, 0, 0 TO shade
            IF shade <> shade0 THEN savChanges = 1
            printPage: DIALOG END CBHNDL
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CB.HNDL
         END IF
      CASE %WM_HSCROLL   
         IF CB.LPARAM = GetDlgItem(CB.HNDL, %IDC_Shade) THEN
            CONTROL SEND CB.HNDL, %IDC_Shade, %TBM_GETPOS, 0, 0 TO shade
            CONTROL SET TEXT CB.HNDL, %IDC_ShadeVal, STR$(shade)
         END IF   
   END SELECT
END FUNCTION

SUB printPage()
   LOCAL xDeadZone, yDeadZone, prnErr, leftPrint, topPrint, ht AS LONG
   LOCAL i, j, hPen, origPen, origFont, origMode, hPrinterDC, m, n, prnAll, done AS LONG
   local xDpi, yDpi AS DOUBLE, s AS STRING
   LOCAL di AS DOCINFO, pt AS POINTAPI
   DIM xUpperLeftCorner(3), yUpperLeftCorner(4)
   hPrinterDC = choosePrinter(0)
   IF hPrinterDC = 0 THEN GOTO WrapUp
   hPen = CreatePen(%PS_SOLID, 4, 0)
   SelectObject hPrinterDC, hPen
   origMode = SetMapMode(hPrinterDC, %MM_TEXT)        'set mapping mode
   if origMode = 0 then goto WrapUp
   xDpi = GetDeviceCaps(hPrinterDC, %LOGPIXELSX)/100  'x-pixels per .01 inch
   yDpi = GetDeviceCaps(hPrinterDC, %LOGPIXELSY)/100  'y-pixels per .01 inch
   ht = GetDeviceCaps(hPrinterDC, %PHYSICALHEIGHT)
   xDeadZone = GetDeviceCaps(hPrinterDC, %PHYSICALOFFSETX)
   yDeadZone = GetDeviceCaps(hPrinterDC, %PHYSICALOFFSETY)
   leftPrint = %LeftMargin * xDpi - xDeadZone + 150
   topPrint = max(%TopMargin * yDpi, yDeadZone)
   monthWi = 7 * %cellWiPrn * xDpi
   monthHt = 6 * %cellHtPrn * yDpi
   xUpperLeftCorner(1) = leftPrint
   xUpperLeftCorner(2) = leftPrint
   s = "October"
   GetTextExtentPoint32 hPrinterDC, byval varptr(s), len(s), pt    'get char size
   yUpperLeftCorner(1) = topPrint + pt.y
   yUpperLeftCorner(2) = ht/2 + pt.y
   di.cbSize = SIZEOF(di)
   di.lpszDocName = VARPTR(s)
   IF StartDoc(BYVAL hPrinterDC, BYVAL VARPTR(di)) <= 0 THEN prnErr = 1: GOTO WrapUp
   CONTROL GET CHECK hPrn, %IDC_All TO prnAll
   '------------------------------------------------------- print months
   IF prnAll = 0 THEN 'just print 2 months
      COMBOBOX GET SELECT hDlg, %IDC_Months TO n: DECR n
   END IF
   DO 
      IF StartPage(hPrinterDC) <= 0 THEN prnErr = 2: GOTO WrapUp
      INCR n
      m = CHOOSE(n, 9, 11, 1, 3, 5, 7) 
      FOR i = m TO m + 1
         j = i - m + 1
         printMonth(hPrinterDC, i, xUpperLeftCorner(j), yUpperLeftCorner(j))
      NEXT i
      IF prnAll = 0 OR n = 6 THEN done = 1
      EndPage hPrinterDC
   LOOP UNTIL done
WrapUp:
   IF prnErr THEN
      s = "Printing error has occured"
      MSGBOX s, %MB_ICONERROR, "Printing Error" + STR$(prnErr)
   END IF
   
   EndDoc hPrinterDC
   SelectObject hPrinterDC, origFont
   SelectObject hPrinterDC, origPen
   SetMapMode hPrinterDC, origMode
   DeleteObject hPen
   DeleteDC hPrinterDC
END SUB

SUB printMonth(hdc AS LONG, month AS LONG, x0 AS LONG, y0 AS LONG)
   LOCAL i, m, n, yr AS LONG
   LOCAL x, y, h, w, u, startDay, days AS LONG
   LOCAL hFont, hBrush, hRgn, charHt, dark AS LONG
   LOCAL s AS STRING, tm AS TEXTMETRIC
   '------------------------------------------------------- print month template
   h = monthHt / 6: w = monthWi / 7: u = w / 5
   FOR i = 0 TO 6   'draw horizontal lines
      y = y0 + i * h
      MoveToEx hdc, x0, y, BYVAL %NULL
      lineTo hdc, x0 + monthWi, y
   NEXT i
   FOR i = 0 TO 7   'draw vertical lines
      x = x0 + i * w
      MoveToEx hdc, x, y0, BYVAL %NULL
      lineTo hdc, x, y0 + monthHt
   NEXT i
   '------------------------------------------------------- print day title
   hFont = makeFont(hdc, 10, "Courier New")
   SelectObject hdc, hFont
   GetTextMetrics hdc, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   y = y0 - 1.1 * charHt
   FOR i = 0 TO 6
      x = x0 + i * w + u: s = dayName(i + 1)
      showText hdc, x, y, s
   NEXT i
   '------------------------------------------------------- print month title
   COMBOBOX GET TEXT hDlg, %IDC_Year TO s
   yr = VAL(LEFT$(TRIM$(s), 4))
   IF month <= 8 THEN INCR yr
   hFont = makeFont(hdc, 12, "Arial", "b")
   SelectObject hdc, hFont
   GetTextMetrics hdc, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   y = y - charHt: x = x0: s = moName(month) + " -" + STR$(yr)
   showText hdc, x, y, s
   '------------------------------------------------------- print calendar days
   hFont = makeFont(hdc, 6)
   SelectObject hdc, hFont
   startDay = dayOfWeek(month, 1, yr)
   days = daysInMonth(month, yr)
   m = 0: n = startDay: u = .10 * w
   dark = 255 - 155/99*(shade - 1)
   FOR i = 1 TO days
      x = x0 + n * w: y = y0 + m * h
      IF holidays(month, i) THEN
         hBrush = CreateSolidBrush(RGB(dark, dark, dark))
         IF holidays(month, i) THEN
            hRgn = CreateRectRgn(x + 1, y + 1, x + w - 1, y + h - 1)
         END IF
         FillRgn hdc, hRgn, hBrush
         DeleteObject hBrush
         DeleteObject hRgn
      END IF
      x = x + u: y = y + u/2
      showText hdc, x, y, TRIM$(STR$(i))
      INCR n: IF n MOD 7 = 0 THEN INCR m: n = 0
   NEXT i
END SUB

FUNCTION choosePrinter(landscape AS LONG) AS DWORD  'LONG
   'return printer device context for selected printer
   'landscape = 1  for landscape
   '          = 0  for portrait
   LOCAL pd AS PRINTDLGAPI, pDevMode AS DEVMODE PTR, hPrnDC AS DWORD  'LONG
   pd.lStructSize = SIZEOF(pd)
   pd.hWndOwner = hDlg
   pd.Flags = %PD_RETURNDC OR %PD_NOSELECTION OR %PD_NOPAGENUMS OR %PD_HIDEPRINTTOFILE
   IF printDlg(pd) THEN
     hPrnDC = pd.hdc
     IF landscape THEN
        pDevMode = GlobalLock(pd.hDevMode)
        @pDevMode.dmOrientation = %DMORIENT_LANDSCAPE
        ResetDC hPrnDC, BYVAL pDevMode
        GlobalUnlock pDevMode
     END IF
   END IF
   FUNCTION = hPrnDC
END FUNCTION

SUB defineHolidays()
   LOCAL nStyle, wi, ht, x0, x1, x2, x3 AS LONG
   LOCAL s AS STRING
   wi = 200: ht = 200
   x0 = 0: x1 = 88: x2 = 133: x3 = 178
   CONTROL GET TEXT hDlg, %IDC_Year TO s
   DIALOG NEW hDlg, "Holidays for" + s, , , 200, 200, %WS_SYSMENU TO hDefineHolidays
   CONTROL ADD LABEL, hDefineHolidays, -1, "Holiday ", x0, 0, x1 - x0, 20, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hDefineHolidays, -1, "Beginning ", x1, 0, x2 - x1, 20, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hDefineHolidays, -1, "Ending ", x2, 0, x3 - x2, 20, %SS_CENTER, %WS_EX_STATICEDGE
   nStyle = %WS_VSCROLL + %LBS_DISABLENOSCROLL + %WS_TABSTOP + %LBS_USETABSTOPS
   CONTROL ADD LISTBOX, hDefineHolidays, %IDC_HolidayLB, , 5, 10, 185, 140, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hDefineHolidays, %IDC_AddHoliday, "&Add", 10, 155, 40, 20
   CONTROL ADD BUTTON, hDefineHolidays, %IDC_EdtHoliday, "&Edit", 50, 155, 40, 20
   CONTROL ADD BUTTON, hDefineHolidays, %IDC_DelHoliday, "&Remove", 90, 155, 40, 20
   CONTROL ADD BUTTON, hDefineHolidays, %IDC_ViewHolidays, "&View", 140, 155, 40, 20
   DIALOG SHOW MODAL hDefineHolidays, CALL defineHolidaysProc
END SUB

CALLBACK FUNCTION defineHolidaysProc
   LOCAL n AS LONG, s AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         listHolidays
      CASE %WM_COMMAND
         IF CBCTL = %IDC_AddHoliday THEN
            holidayNo = 0: addHoliday
         ELSEIF CBCTL = %IDC_EdtHoliday THEN
            CONTROL SEND CBHNDL, %IDC_HolidayLB, %LB_GETCURSEL, 0, 0 TO n
            holidayNo = n + 1: addHoliday
         ELSEIF CBCTL = %IDC_DelHoliday THEN
            CONTROL SEND CBHNDL, %IDC_HolidayLB, %LB_GETCURSEL, 0, 0 TO n
            holidayNo = n + 1: s = "Remove this holiday now?      "
            n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, holidayName(holidayNo))
            IF n = %IDYES THEN
               deleteHoliday(holidayNo): markHolidays: listHolidays
            END IF
         ELSEIF CBCTL = %IDC_ViewHolidays THEN
            viewHolidays
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         END IF
         CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
   END SELECT
END FUNCTION

SUB addHoliday()
   LOCAL hAddHoliday, wi, ht AS LONG
   LOCAL s AS STRING
   wi = 200: ht = 170
   IF holidayNo THEN s = "Edit" ELSE s = "Add"
   DIALOG NEW hDefineHolidays, s + " Holiday", 20, 20, wi, ht, %WS_SYSMENU TO hAddHoliday
   CONTROL ADD LABEL, hAddHoliday, -1, "Holiday:", 10, 20, 40, 15
   CONTROL ADD TEXTBOX, hAddHoliday, %IDC_HolidayName, "", 50, 20, 100, 15
   CONTROL ADD LABEL, hAddHoliday, -1, "Beginning month-day:", 10, 50, 50, 20
   CONTROL ADD TEXTBOX, hAddHoliday, %IDC_HolidayDate1, "", 50, 50, 40, 15
   CONTROL ADD LABEL, hAddHoliday, -1, "Ending month-day:", 10, 80, 50, 20
   CONTROL ADD TEXTBOX, hAddHoliday, %IDC_HolidayDate2, "", 50, 80, 40, 15
   CONTROL ADD BUTTON, hAddHoliday, %IDOK, "Ok", 40, ht - 40, 50, 20
   CONTROL ADD BUTTON, hAddHoliday, %IDCANCEL, "&Cancel", 100, ht - 40, 50, 20
   DIALOG SHOW MODAL hAddHoliday, CALL addHolidayProc
END SUB

CALLBACK FUNCTION addHolidayProc()
   LOCAL i, j, n, k, mo, day, nn AS LONG
   LOCAL s, s1 AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         IF holidayNo THEN 'editing holiday
            CONTROL SET TEXT CBHNDL, %IDC_HolidayName, holidayName(holidayNo)
            n = holidayDate1(holidayNo)
            s = FORMAT$(n \ 100, "00"): s1 = FORMAT$(n MOD 100, "00")
            CONTROL SET TEXT CBHNDL, %IDC_HolidayDate1, s + "-" + s1
            n = holidayDate2(holidayNo)
            IF n THEN
               s = FORMAT$(n \ 100, "00"): s1 = FORMAT$(n MOD 100, "00")
               CONTROL SET TEXT CBHNDL, %IDC_HolidayDate2, s + "-" + s1
            END IF
         END IF
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN
            savChanges = 1
            IF holidayNo THEN deleteHoliday(holidayNo) 'edit holiday
            CONTROL GET TEXT CBHNDL, %IDC_HolidayDate1 TO s
            mo = VAL(PARSE$(s, "-", 1)): day = VAL(PARSE$(s, "-", 2))
            n = 100 * mo + day: holidays(mo, day) = 1
            IF mo <= 8 THEN nn = n + 1200 ELSE nn = n 
            CONTROL GET TEXT CBHNDL, %IDC_HolidayDate2 TO s
            mo = VAL(PARSE$(s, "-", 1)): day = VAL(PARSE$(s, "-", 2))
            k = 100 * mo + day: holidays(mo, day) = 1
            IF k = n THEN k = 0
            
            DIM order(numHolidays) AS LONG
            FOR i = 1 TO numHolidays
               j = holidayDate1(i)
               mo = j \ 100: day = j MOD 100 
               IF mo <= 8 THEN mo = 12 + mo
               order(i) = 100 * mo + day
            NEXT i
            ARRAY SCAN order(), > nn, TO holidayNo
            IF holidayNo > 1 THEN DECR holidayNo
            INCR numHolidays
            IF holidayNo = 0 THEN holidayNo = numHolidays
            CONTROL GET TEXT CBHNDL, %IDC_HolidayName TO s
            ARRAY INSERT holidayName(holidayNo), s
            ARRAY INSERT holidayDate1(holidayNo), n
            ARRAY INSERT holidayDate2(holidayNo), k
            listHolidays: markHolidays: DIALOG END CBHNDL
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         END IF
   END SELECT
END FUNCTION

SUB deleteHoliday(index AS LONG)
   LOCAL mo, day AS LONG
   mo = holidayDate1(index)\100
   day = holidayDate1(index) MOD 100
   holidays(mo, day) = 0
   DECR numHolidays: savChanges = 1
   ARRAY DELETE holidayName(index)
   ARRAY DELETE holidayDate1(index)
   ARRAY DELETE holidayDate2(index)
END SUB

SUB listHolidays
   LOCAL i AS LONG, mo AS LONG, day AS LONG, lptr AS LONG PTR
   LOCAL s AS STRING, s1 AS STRING, s2 AS STRING
   DIM tabstops(2) AS LONG
   tabstops(0) = 0     'holiday name
   tabstops(1) = 100   'holiday begin date
   tabstops(2) = 140   'holiday end date
   lptr = VARPTR(tabstops(0))
   CONTROL SEND hDefineHolidays, %IDC_HolidayLB, %LB_SETTABSTOPS, 3, lptr
   LISTBOX RESET hDefineHolidays, %IDC_HolidayLB
   FOR i = 1 TO numHolidays
      mo = holidayDate1(i) / 100: day = holidayDate1(i) MOD 100
      s1 = FORMAT$(mo, "00") + "-" + FORMAT$(day, "00")
      s2 = ""
      IF holidayDate2(i) THEN
         mo = holidayDate2(i) / 100: day = holidayDate2(i) MOD 100
         s2 = FORMAT$(mo, "00") + "-" + FORMAT$(day, "00")
      END IF
      s = holidayName(i) + $TAB + s1 + $TAB + s2 
      LISTBOX ADD hDefineHolidays, %IDC_HolidayLB, s
   NEXT i
   LISTBOX SELECT hDefineHolidays, %IDC_HolidayLB, MAX(holidayNo, 1)
END SUB

SUB viewHolidays()
   'view holidays by calendar months
   LOCAL STYLE AS LONG
   STYLE = %DS_MODALFRAME OR %WS_BORDER OR %WS_CAPTION OR %WS_CLIPSIBLINGS OR %WS_DLGFRAME
   STYLE = STYLE OR %WS_POPUP OR %WS_VSCROLL OR %WS_SYSMENU OR %WS_MINIMIZEBOX
   DIALOG NEW hDefineHolidays, STR$(year) + " Holidays", , , 500, 270, STYLE TO hViewHolidays
   DIALOG SET COLOR hViewHolidays, -1, %WHITE
   DIALOG SHOW MODAL hViewHolidays, CALL viewHolidaysProc
END SUB

CALLBACK FUNCTION viewHolidaysProc()
   LOCAL hPen AS LONG, horizSpac AS LONG, xDpi AS LONG, yDpi AS LONG
   LOCAL i AS LONG, m AS LONG, n AS LONG, row AS LONG, col AS LONG
   LOCAL ps AS PAINTSTRUCT, x AS LONG, y AS LONG, view AS BYTE
   STATIC hdc AS LONG, si AS SCROLLINFO
   DIM xUpperLeftCorner(3), yUpperLeftCorner(4)
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         hdc = Getdc(CBHNDL)
         hPen = CreatePen(%PS_SOLID, 1, 0)
         SelectObject hdc, hPen
         xDpi = GetDeviceCaps(hdc, %LOGPIXELSX)/100  'x-pixels per .01 inch
         yDpi = GetDeviceCaps(hdc, %LOGPIXELSY)/100  'y-pixels per .01 inch
         monthWi = 7 * %cellWi * xDpi
         monthHt = 6 * %cellHt * yDpi
         horizSpac = 20
         xUpperLeftCorner(1) = 20
         xUpperLeftCorner(2) = xUpperLeftCorner(1) + monthWi + horizSpac * xDpi
         xUpperLeftCorner(3) = xUpperLeftCorner(2) + monthWi + horizSpac * xDpi
         yUpperLeftCorner(1) = 50
         yUpperLeftCorner(2) = yUpperLeftCorner(1) + monthHt + %VertSpac * yDpi
         yUpperLeftCorner(3) = yUpperLeftCorner(2) + monthHt + %VertSpac * yDpi
         yUpperLeftCorner(4) = yUpperLeftCorner(3) + monthHt + %VertSpac * yDpi
         'set scroll information --------------------------------------------------------
         si.cbSize = SIZEOF(si): si.fMask = %SIF_ALL
         si.nMin = 0: si.nMax = 2: si.nPos = 0: si.nPage = 2
         SetScrollInfo BYVAL CBHNDL, BYVAL %SB_VERT, si, 1
         vpos = 0
      CASE %WM_PAINT
         hdc = BeginPaint(CBHNDL, ps)
            IF vpos THEN n = 1 ELSE n = 7
            FOR i = n TO n + 5
               m = i - n: row = (m \ 3) + 1: col = (m MOD 3) + 1
               x = xUpperLeftCorner(col): y = yUpperLeftCorner(row)
               printMonth hdc, i, x, y
            NEXT i
         EndPaint CBHNDL, ps
      CASE %WM_VSCROLL
         SELECT CASE LOWRD(CBWPARAM)
            CASE %SB_LINEDOWN
               IF vpos < 3 THEN vpos = 3: view = 1
            CASE %SB_LINEUP
               IF vpos > 0 THEN vpos = 0: view = 1
            CASE %SB_THUMBTRACK
               vpos = HIWRD(CBWPARAM): view = 1
            CASE %SB_PAGEDOWN
               IF vpos < 3 THEN vpos = 3: view = 1
            CASE %SB_PAGEUP
               IF vpos > 0 THEN vpos = 0: view = 1
         END SELECT
         IF view THEN
            view = 0
            SetScrollPos CBHNDL, %SB_VERT, vPos, 1
            InvalidateRect CBHNDL, BYVAL %NULL, 1
         END IF
      CASE %WM_COMMAND
         IF CBCTL = %IDCANCEL THEN DIALOG END CBHNDL
   END SELECT
END FUNCTION

SUB getHolidayDates()
   LOCAL i, n, mo, day AS LONG
   FOR i = 1 TO numHolidays
      mo = holidayDate1(i) / 100: day = holidayDate1(i) MOD 100
      IF holidayDate1(i) < 0 THEN 'date has been overriden, don't change
         ITERATE
      ELSEIF holidayDate1(i) = 0 THEN
         IF INSTR(HolidayName(i), "Labor") THEN
            mo = 9: n = dayOfWeek(mo, 1, year)
            IF n > 1 THEN day = 9 - n ELSE day = 2 - n
         ELSEIF INSTR(holidayName(i), "Thanksgiving") THEN
            mo = 11: n = dayOfWeek(mo, 1, year): day = 26 - n
            holidayDate1(i) = mo * 100 + day
         ELSEIF INSTR(holidayName(i), "Presidents") THEN
            mo = 2: n = dayOfWeek(mo, 1, year + 1): day = 23 - n
         END IF
         holidayDate1(i) = mo * 100 + day
      END IF
   NEXT i
END SUB

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   daysInMonth = days
END FUNCTION

FUNCTION dayOfWeek(mo AS LONG, day AS LONG, yr AS LONG) AS LONG
   'Sun=0, Mon=1, Tue=2,... Sat=6
   LOCAL n AS INTEGER
   n = yr - 1899 + (yr - 1901) \ 4
   IF mo < 8 THEN
      n = n + 30 * (mo - 1) + mo \ 2
   ELSE
      n = n + 30 * (mo - 1) + (mo + 1) \ 2
   END IF
   IF mo > 2 THEN
      n = n - 2
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN IF mo > 2 THEN INCR n 'leap yr
   END IF
   FUNCTION = (n + day - 1) MOD 7
END FUNCTION

SUB showText(hdc AS LONG, x AS LONG, y AS LONG, txt AS STRING)
   SetBkMode(hdc, %TRANSPARENT)
   TextOut hdc, x, y, BYVAL STRPTR(txt), LEN(txt)
END SUB

FUNCTION MakeFont(hDC AS LONG, BYVAL ptSize AS LONG, _
                  OPT BYVAL sFont AS STRING, BYVAL descr AS STRING) AS LONG
   'some font choices: "Arial", "Courier New", "Times New Roman", "MS Sans Serif", "Tahoma"
   'default font: "Arial"; fixed width font: "Courier New"
   'specify descr = "b" for bold, "u" for underline, "i" for italic
   LOCAL CyPixels AS LONG, charHt AS LONG, wt AS DWORD
   LOCAL bold AS DWORD, underline AS DWORD, italic AS DWORD
   IF LEN(sFont) = 0 THEN sFont = "Arial"
   IF LEN(descr) THEN
      bold = INSTR(descr, "b") + 300
      underline = INSTR(descr,"u")
      italic = INSTR(descr,"i")
   END IF
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (PtSize * CyPixels) \ 72
   wt = %FW_NORMAL + bold
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY sFont)
END FUNCTION

SUB createFolder(folder AS STRING)
   LOCAL i, n AS LONG
   LOCAL f, s AS STRING
   n = PARSECOUNT(folder, "\")
   FOR i = 1 TO n
      f = PARSE$(folder, "\", i)
      IF LEN(f) THEN 
         s = s + f + "\"
         IF ISFILE(s) = 0 THEN MKDIR s
      END IF 
   NEXT i
END SUB

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION
